html
  head
    title !{title}
    style
      include style.css
  body
    h1 Monitoring trains !{trains}
    h2(id='status') Status: Loading...
    button(onclick="pause()") Pause 
    button(onclick="resume()") Resume 
    button(onclick="reset()") Reset
    each train in trains 
      div(class="solution-box")
        h2 Train !{train}
        div(id=train + "-info")
        
    script(src="https://cdn.socket.io/4.0.1/socket.io.min.js" integrity="sha384-LzhRnpGmQP+lOvWruF/lgkcqD+WDVt9fU3H4BWmwP5u5LTmkUGafMcpZKNObVMLU" crossorigin="anonymous")
    script.
      const socket = io("http://localhost:3000");

      socket.emit("monitoring", "!{trains}");
      
      socket.on('trains-status', (trainsStatus) => {
        console.log("Monitoring received");
        console.log(trainsStatus);
        trainsStatus = JSON.parse(trainsStatus);
        fillBoxes(trainsStatus.trains);
        fillStatus(trainsStatus.status);
      });

      function fillStatus(status) {
        let statusHead = document.getElementById("status");
        statusHead.innerHTML = "Status: " + status;
      } 

      function fillBoxes(trains) {
        trains.forEach((train) => {
            let box = document.getElementById(train.id + "-info");
            box.innerHTML = "";
            if(!train.isDeparted) {
              appendTextToDiv(box, "Situation: The train hasn't departed yet!");
            } else {
              appendHeaderToDiv(box, "Departure");
              appendTextToDiv(box, "Station: " + train.departure.station);
              appendTextToDiv(box, "Scheduled Time: " + train.departure.scheduledTime);
              appendTextToDiv(box, "Actual Time: " + train.departure.actualTime);
              appendTextToDiv(box, "Scheduled Platform: " + train.departure.scheduledPlatform);
              appendTextToDiv(box, "Actual Platform: " + train.departure.actualPlatform);

              train.lastStop.forEach((stop, i) => {
              appendHeaderToDiv(box, "Stop #" + i);
              appendTextToDiv(box, "Station: " + stop.station);
              appendTextToDiv(box, "Scheduled Time: " + stop.scheduledTime);
              appendTextToDiv(box, "Actual Time: " + stop.actualTime);
              });

              appendHeaderToDiv(box, "Arrival");
              appendTextToDiv(box, "Station: " + train.arrival.station);
              appendTextToDiv(box, "Scheduled Time: " + train.arrival.scheduledTime);
              appendTextToDiv(box, "Actual Time: " + train.arrival.actualTime);
              appendTextToDiv(box, "Scheduled Platform: " + train.arrival.scheduledPlatform);
              appendTextToDiv(box, "Actual Platform: " + train.arrival.actualPlatform);
            }
        });
      }

      function appendHeaderToDiv(div, text) {
        let node = document.createElement("h3");
        let textNode = document.createTextNode(text); 
        node.appendChild(textNode);
        div.appendChild(node);
      }

      function appendTextToDiv(div, text) {
        let node = document.createElement("p");
        let textNode = document.createTextNode(text); 
        node.appendChild(textNode);
        div.appendChild(node);
      }

      function pause() {
        console.log("Pause requested");
        socket.emit("pause", "");
      }

      function resume() {
        console.log("Resume requested");
        socket.emit("resume", "");
      }

      function reset() {
        console.log("Reset requested");
        socket.emit("reset", "");
      }
      